unit uBaum;

interface

uses
dialogs;

type

tZeiger=^knoten;   // typisierter Zeiger!

knoten=record
  plz, ort: string;
  links, rechts: tZeiger;
end;

tBaum=class
 private
  zneu, zhilf, zwurzel: tZeiger;
  ausgabe: string;
 public
  procedure neu_dazu(p,o: string);
  procedure einordnen;
  {procedure pre_order(z: tzeiger);
  procedure in_order(z: tzeiger);
  procedure post_order(z: tzeiger);
  function ausgeben(mode: string): string;}
  procedure suchen(z: tzeiger; gesucht: string);
  function suchstart(gesucht:string): string;

end;

var
ar:array of knoten;

implementation

procedure tBaum.neu_dazu(p,o: string);
begin
  new(zneu);
  zneu^.plz:= p;
  zneu^.ort:= o;
  zneu^.links:= nil;
  zneu^.rechts:= nil;

  if zwurzel = nil then zwurzel:= zneu else
   begin
     zhilf:= zwurzel;
     einordnen;
   end;

end;

procedure tBaum.einordnen;
begin
  if zneu^.ort > zhilf^.ort then  // Ort = Schlssel - danach sortiert
   begin
     //showmessage('Rechts nach Vergleich mit ' + zHilf.daten);
     if zHilf^.rechts = nil then zHilf^.rechts:= zneu
      else
      begin
        zHilf:= zHilf.rechts;
        einordnen;
      end;
   end
  else
   begin
     //showmessage('Links nach Vergleich mit ' + zHilf.daten);
     if zHilf^.links = nil then zHilf^.links:= zneu
      else
      begin
        zHilf:= zHilf.links;
        einordnen;
      end;
   end;
end;

{procedure tBaum.pre_order(z: tzeiger);
begin
  if z <> nil then
   begin
     ausgabe:= ausgabe + z^.daten + ' ';
     pre_order(z^.links);
     pre_order(z^.rechts);
   end;
end;

procedure tBaum.in_order(z: tzeiger);
begin
  if z <> nil then
   begin
     in_order(z^.links);
     ausgabe:= ausgabe + z^.daten + ' ';
     in_order(z^.rechts);
   end;
end;

procedure tBaum.post_order(z: tzeiger);
begin
  if z <> nil then
   begin
     post_order(z^.links);
     post_order(z^.rechts);
     ausgabe:= ausgabe + z^.daten + ' ';
   end;
end;

function tBaum.ausgeben(mode: string): string;
begin
  ausgabe:= '';
  if zWurzel = nil then
   Showmessage('Is leer ey!' ) else
   begin
    zHilf:= zwurzel;
    if mode='pre' then pre_order(zHilf) else
    if mode='post' then post_order(zHilf) else
    if mode='in' then in_order(zHilf);
   end;

  result:= ausgabe;
end;}

procedure tBaum.suchen(z: tZeiger; gesucht: string);
begin
 if z<>nil then
  if z^.ort=gesucht then ausgabe:= z^.plz
  else
   if gesucht < z^.ort then
     suchen(z^.links, gesucht)
   else
     suchen(z^.rechts, gesucht);
end;

function tBaum.suchstart(gesucht: string): string;
begin
  ausgabe:= '';
  zhilf:= zwurzel;
  suchen(zhilf, gesucht);
  result:= ausgabe;
end;


end.
